SizeMove.prg

* Program: SizeMove.prg
* Author:  F. Ho
* Version: Clipper Summer '87
* Note(s): This routine Sizes and Moves a MEMOEDIT() box.
*
* Copyright (c) 1988 Nantucket Corp.

CLEAR
@ 23, 01 SAY "Hello!"
note = MEMOREAD("Sample.txt")
INKEY(2)
CLEAR
TEXT

   1. To re-SIZE MEMOEDIT() box:

       - ALT-S:       Go into SIZE mode
       - Cursor keys: Extend respective sides
       - ESC/RETURN:  Quit SIZE mode

   2. To MOVE MEMOEDIT() box:

       - ALT-M:       Go into MOVE mode
       - Cursor keys: Determine direction of movement
       - ESC/RETURN:  Quit MOVE mode

ENDTEXT

@ 23, 01 SAY "<Esc> to quit"
x = Mem_it(note)
@ 23, 01 SAY "Goodbye!     "
RETURN


FUNCTION Mem_it
PARAMETERS p1
SAVE SCREEN TO scr0
SET KEY 306 TO Move_mode           && Alt-M to move window.
SET KEY 287 TO Size_mode           && Alt-S to size window.

* Initial window coordinates:
*
wtt = 15                           && Top.
wll = 10                           && Left.
wbb = 19                           && Bottom.
wrr = 70                           && Right.

* Main MEMOEDIT() routine.
DO WHILE .T.
   sm_mode = .F.
   RESTORE SCREEN FROM scr0
   @ wtt - 1, wll - 1 TO wbb + 1, wrr + 1 DOUBLE
   p1 = MEMOEDIT(p1, wtt, wll, wbb, wrr, .F., "", 250)
   IF LASTKEY() = 27 .AND. .NOT. sm_mode
      EXIT
   ENDIF
ENDDO
RESTORE SCREEN FROM scr0

* Turn off SET KEYs.
SET KEY 28 TO
SET KEY 306 TO 
SET KEY 287 TO
RETURN(p1)


* MOVE window mode routine.
*
PROCEDURE Move_mode
PARAMETERS p1, p2, p3
SAVE SCREEN TO scr1
move_flag = .T.
DO WHILE move_flag
   RESTORE SCREEN FROM scr1
   lbx = CHR(176)
   @ wtt, wll, wbb, wrr box "M" + lbx + "O" + lbx + "V" +;
      lbx + "E" + lbx
   mink = INKEY(0)
   DO CASE
   CASE (mink = 27) .or. (mink = 13)
      move_flag = .F.
      sm_mode = .T.
      LOOP
   CASE mink = 24
      wbb = wbb + 1
      IF wbb > 22
         wbb = 22
      ELSE
         wtt = wtt + 1
      ENDIF
   CASE mink = 5
      wtt = wtt - 1
      IF wtt < 2
         wtt = 2
      ELSE
         wbb = wbb - 1
      ENDIF
   CASE mink = 19
      wll = wll - 1
      IF wll < 2
         wll = 2
      ELSE
         wrr = wrr - 1
      ENDIF
   CASE mink = 4
      wrr = wrr + 1
      IF wrr > 78
         wrr = 78
      ELSE
         wll = wll + 1
      ENDIF
   ENDCASE
ENDDO
KEYBOARD CHR(27)
RETURN

* Re-SIZE window mode routine.
*
PROCEDURE Size_mode
PARAMETERS p1, p2, p3
SAVE SCREEN TO scr1
size_flag = .T.
DO WHILE size_flag
   RESTORE SCREEN FROM scr1
   lbx = CHR(176)
   @ wtt, wll, wbb, wrr box "S" + lbx + "I" + lbx + "Z" +;
      lbx + "E" + lbx
   mink = INKEY(0)

   DO CASE
   CASE (mink = 27) .or. (mink = 13)
      size_flag = .F.
      sm_mode = .T.
      LOOP
   CASE mink = 24
      wbb = IF(((wbb + 1) > 22), 22, wbb + 1)
   CASE mink = 5
      wtt = IF(((wtt - 1) < 2), 2, wtt - 1)
   CASE mink = 19
      wll = IF(((wll - 1) < 2), 2, wll - 1)
   CASE mink = 4
      wrr = IF(((wrr + 1) > 78), 78, wrr + 1)
    ENDCASE
ENDDO
KEYBOARD CHR(27)
RETURN
